var cssMediaQuery = require('css-mediaquery')
// only filter out: print, min-width > width and min-height > height

function _isMatchingMediaQuery (rule, matchConfig) {
  if (rule.type !== 'media') {
    // ignore (keep) all non media query rules
    return true
  }

  var mediaAST = cssMediaQuery.parse(rule.media)
  var keep = mediaAST.some(function (mq) {
    if (mq.type === 'print') {
      return false
    }
    return mq.expressions.some(function (expression, index) {
      if (expression.modifier === 'min') {
        return cssMediaQuery.match('(min-' + expression.feature + ':' + expression.value + ')', matchConfig)
      } else {
        return true
      }
    })
  })
  return keep
}

function nonMatchingMediaQueryRemover (rules, width, height) {
  var matchConfig = { type: 'screen', width: width + 'px', height: height + 'px' }
  return rules.filter(function (rule) {
    return _isMatchingMediaQuery(rule, matchConfig)
  })
}

if (typeof module !== 'undefined') {
  module.exports = nonMatchingMediaQueryRemover
}
